window.K2m = window.K2m || {};
window.K2m.Tools = window.K2m.Tools || {};
window.K2m.Tools = {
  loadScript: function(url, success) {
    var script = document.createElement("script");
    script.src = url;
    var head = document.getElementsByTagName("head")[0],
      done = false;
    script.onload = script.onreadystatechange = function() {
      if (
        !done &&
        (!this.readyState ||
          this.readyState == "loaded" ||
          this.readyState == "complete")
      ) {
        done = true;
        success();
        script.onload = script.onreadystatechange = null;
        head.removeChild(script);
      }
    };
    head.appendChild(script);
  }
};

const GetQueryStringParam = function(name) {
  var result = null;
  if (location.search !== "") {
    var querystring = location.search.substring(1).replace(/\+/g, " ");
    var pairs = querystring.split("&");
    var isFound = false;
    for (var i = 0; i < pairs.length; i++) {
      var pair = pairs[i].split("=");
      var key = decodeURIComponent(pair[0]);
      if (key === name) {
        var val = pair.length === 2 ? decodeURIComponent(pair[1]) : key;
        if (!isFound) {
          isFound = true;
          result = [val];
        } else {
          result.push(val);
        }
      }
    }
    if (isFound && result.length == 1 && !/\[.*\]$/.test(name)) {
      result = result[0];
    }
  }
  return result;
};

const doHighlights = function() {
  const highlight = GetQueryStringParam("s");
  if (!highlight) return;

  $("body > .container").each((a, e) => {
    var baseHtml = $(e).html();
    console.info(a, e);
    highlight.split(",").forEach(item => {
      baseHtml = baseHtml.replace(
        item,
        '<em class="search-highlight">' + item + "</em>"
      );
    });
    $(e).html(baseHtml);
  });
};

(function($) {
  $.fn.goTo = function(ratioTopScroll) {
    $("html, body").animate(
      {
        scrollTop: $(this).offset().top / ratioTopScroll + "px"
      },
      "fast"
    );
    return this; // for chaining...
  };
})(jQuery);

Search = function() {};

Search.SearchAction = function() {
  var query = $('[name="pesquisa"]').val();
  var baseSearchUrl = $('[name="pesquisa"]').data("searchbaseurl");
  window.location = baseSearchUrl + "?q=" + query;
};

$('[name="pesquisa"]').keypress(function(e) {
  var key = e.which;
  if (key == 13) {
    // the enter key code
    Search.SearchAction();
    return false;
  }
});

$(function() {
  doHighlights();

  if (typeof Storage !== "undefined") {
    $(".k2m-high-contrast").click(function() {
      $("body").toggleClass("highcontrast");
      var contrast = $("body").attr("class");
      localStorage.setItem("contrast", contrast);
      return false;
    });

    window.onload = function() {
      var contrast = localStorage.getItem("contrast");
      if (contrast != undefined || contrast != null) {
        jQuery("body").attr("class", contrast);
      }
    };
  } else {
    return false;
  }

  $(".k2m-zoom-in").click(function() {
    updateZoom(0.1);
    return false;
  });

  $(".k2m-zoom-out").click(function() {
    updateZoom(-0.1);
    return false;
  });

  zoomLevel = 1;

  var updateZoom = function(zoom) {
    zoomLevel += zoom;
    $("body").css({
      zoom: zoomLevel,
      "-moz-transform": "scale(" + zoomLevel + ")"
    });
  };
});
